#include "windows.h"
#include <stdio.h>
#include "hash58.h"

int main(int argc, char* argv[])
{
	//put yours here to test!
	unsigned char fwid[8] = {
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	};

	//load file
	HANDLE hFile = CreateFile("c:\\iTunesDB", FILE_ALL_ACCESS, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	HANDLE hFM = CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
	BYTE *pData = (BYTE*)MapViewOfFile(hFM, FILE_MAP_READ, 0, 0, 0);
	DWORD dwSize = GetFileSize(hFile, NULL);

	BYTE *pCopy = new BYTE[dwSize];

	//blank out header values
	memcpy(pCopy, pData, dwSize);
	memset(pCopy+0x18, 0, 8);
	memset(pCopy+0x32, 0, 20);
	memset(pCopy+0x58, 0, 20);

	//calculate
	unsigned char hash58[20];
	GenerateHash(fwid, pCopy, dwSize, hash58);

	int i, j;
	printf("Hash58:\n");
	for (i = 0; i < 5; i++) {
		for (j = 0; j < 4; j++) {
			printf("%02X", hash58[i*4+j]);
		}
		putchar(' ');
	}
	putchar('\n');

	printf("Original hash:\n");
	for (i = 0; i < 5; i++) {
		for (j = 0; j < 4; j++) {
			printf("%02X", pData[0x58+i*4+j]);
		}
		putchar(' ');
	}
	putchar('\n');
	
	UnmapViewOfFile(pData);
	CloseHandle(hFM);
	CloseHandle(hFile);
}

